<?php

$spxsNS = 'http://www.spinetix.com/namespace/1.0/spxstatus';
$spxsP = 'spxs';

require_once "/usr/share/resources/default/interface/branding.php"; // branding info

// Serial number
function getInfoSerial( &$serial, &$model, &$hardware ) {
	$serial="[undefined]";
	$cpuinfo=file_get_contents("/proc/cpuinfo");
	if (preg_match("/Serial\s+:\s+(\S+)/",$cpuinfo,$match))
		$serial=$match[1];
	
	$model = "Bonsai";
	if (preg_match("/Hardware\W+:\s+(\w+)/",$cpuinfo,$match)){
		$model = $match[1];
	}
	$hardware = "x.x/x.x";
	if (preg_match("/Revision\W+:\s+(\w+)/",$cpuinfo,$match)){
		if ( $model=='Bonsai') {
			$val=hexdec($match[1]);
			$valc= floor($val/65536);
			$core = floor($valc/256).".".($valc % 256);
			$valc= $val % 65536;
			$carier = floor($valc/256).".".($valc % 256);
			$hardware= $core."/".$carier ;
		} else {
			$val=hexdec($match[1]);
			$valc= $val % 65536;
			$carier = floor($valc/256).".".($valc % 256);
			$hardware= $carier ;
		}
	}
}
function getInfoModel() {
	global $product;
	return $product;
}

function getStorageSizes( $model ) {

    if ( $model=="Bonsai" ) 
        $name = "mmcblk0";
    else 
        $name = "hda";
    $disk = file_get_contents("/proc/partitions");
    $devs = explode("\n", $disk );
    
    $sizes = array();
    foreach ( $devs as $dev ) {
        $data = preg_split("/[\s]+/", $dev );
        if ( count($data==5) && $data[4]==$name ) {
            $sdata = array( "location"=>"internal", "size"=> $data[3], "unit" => "KiB" );
            $sizes[] = $sdata;
        }
    }
    return $sizes;
}

function getInfoSafeMode() {
	return file_exists("/var/run/raperca.safe");
}

function getInfoUpTime() {
	$uptime=file_get_contents("/proc/uptime");
	$uptime=explode(" ",$uptime);
	return $uptime[0];
}

function getInfoIpv6( ) {
    $ipcmd = shell_exec('ip -o -f inet6 addr show eth0');
	preg_match_all("@^\d+:\s*\S+\s+.*\binet6\s+([0-9a-fA-F:]+)@m", $ipcmd, $matches, PREG_SET_ORDER);
    $addrs = array();
	foreach ($matches as $idx => $value) {
        $addrs[] = $value[1];
    }
    return $addrs;
}

function getInfoIp( &$ip, &$ipprefix, &$iptype) {
	$ipcmd=shell_exec('ip -o -f inet addr show');
	preg_match_all("@^\d+:\s*(\S+)\s+.*\binet\s+([\d.]+)(?:/(\d+)|\s+)@m", $ipcmd, $matches, PREG_SET_ORDER);

	# Multidimensional array. Each IP
    # address gets a row, and each row has three entries: the IP
    # address, prefix length, interface type (e.g., 'ethernet',
    # 'modem') and the interface name (e.g., 'eth0', 'ppp0'). The "main"
    # address is returned in the first row. The loopback interface
    # is not returned.
	$addrs = array();
	foreach ($matches as $idx => $value) {
		$iface = $value[1];
		$addr = $value[2];
		$plen = $value[3];

		if ( ! $plen )
			$plen = 32;

		$order = 0; // to order the addresses by decreasing importance

		// add n in [0-99] to ordering to keep ordering if all other
		// ordering criteria are equal
		$order += $idx;

		if ( strncmp($iface, 'eth', 3) == 0 )
			$type = 'ethernet';
		elseif ( strncmp($iface, 'ppp', 3) == 0 )
			$type = 'modem';
		elseif ( $iface == 'lo' )
			$type = 'loopback';
		if ( $iface == 'lo' )
			continue;

		// add n*100 to order for interface type (n in [0,9])
		if ( $type == 'modem' )
			$order += 100;
		elseif ( $type == 'ethernet' )
			$order += 800;
		else
			$order += 900;

		// add n*1000 to order for address class (n in [0,9])
		if (strncmp($addr, '169.254', 7) == 0 )
			$order += 8000; // link-local
		if (strncmp($addr, '127.', 4) == 0 )
			$order += 9000; // host-local

		$addrs[$order] = array($addr, $plen, $type, $iface);
	}

	// apply the ordering
	ksort($addrs);
	$addr = reset($addrs);
	if ($addr) {
		$ip=$addr[0];
		$ipprefix=$addr[1];
		$iptype=ucfirst($addr[2]);
	} else {
		$ip = "[not found]";
		$ipprefix = "";
		$iptype= "Unknown";
	}
	return $addrs;
}
function getInfoMac () {
	if ( isset($_ENV['OS']) && $_ENV['OS']=='Windows_NT' ) {
		return "00:1D:50:00:00:XX";
	} else {
		$info=`ifconfig eth0`;
		$macp=strpos($info,"HWaddr ");
		if ($macp===false) 
			return "[not found]";
		$macp=$macp+strlen("HWaddr ");
		return substr($info, $macp, strpos($info," ",$macp)-$macp);
	}            
}
function getInfoHostname() {
	return trim(file_get_contents("/etc/hostname"));
}  
function getUBootVersion() {
    return shell_exec("LC_ALL=C tr -c '[ -~]' '\n' < /dev/mtd0 | grep 'U-Boot [0-9]' | head -n 1");
}  


function getInfoFirmware( &$firmware, &$build ) {
	$release = file_get_contents('/etc/spinetix-release');
	$vals=explode(" ", $release);
	if (count($vals)==6 ){
		$firmware = $vals[3];
		$build = $vals[5];
	} else {
		$firmware = "[not found]";
		$build = "";
	}
}

function getInfoFirmwareCorrupted(){
	return trim(file_get_contents("/var/lib/updater/status"))==="CORRUPTED";
}

function getInfoTemperature () {
	$ret = array();
	$temp = file_get_contents("/sys/class/hwmon/hwmon0/device/temp1_input");
	if ( $temp=="" )
		$ret['temp'] = "[not found]";
	else
		$ret['temp'] = intval($temp)/1000;
	
	$temp = file_get_contents("/sys/class/hwmon/hwmon0/device/temp1_max_alarm");
	if ( trim( $temp) =="1")
		$ret['max']= true;
	else
		$ret['max']= false;
	$temp = file_get_contents("/sys/class/hwmon/hwmon0/device/temp1_crit_alarm");
	if ( trim( $temp) =="1")
		$ret['crit']= true;
	else
		$ret['crit']= false;
	
	return $ret;
}

class ipconfigBasics{
	const NET_ETHERNET = "ethernet";
	const NET_MODEM = "modem";
	var $netiface=self::NET_ETHERNET;
	var $dhcp=1;
	var $address="";
	var $netmask="";
	var $gateway="";
	var $hostname="";

	var $startTag="# START-spxsysconfig DO NOT REMOVE THE START AND END TAGS";
	var $endTag="# END-spxsysconfig";
	var $fname="/etc/network/interfaces";
	function mask($adr,$msk){
		$a=ip2long($adr);
		$m=ip2long($msk);
		return long2ip($a & $m);
	}
	function broad($adr,$msk){
		$a=ip2long($adr);
		$m=ip2long($msk);
		
		return long2ip(($a & $m)+(~$m));
	}

	function load(){
		 // get the config
		$interface=file_get_contents($this->fname);
		if (!isset($interface) && $interface) {
            echo "<p style='color:red'>Warning: cannot read configuration file </p>"; 
            return;
        }
	
		$start=strpos($interface,$this->startTag);
		$end=strpos($interface,$this->endTag);
		if ($start===false || $end===false) {
            echo "<p style='color:red'>Warning: configuration file is incomplete</p>"; 
            return;
        }

		// should look for first auto interface to be
		// consistent with ifwatchdog
		$str1="auto ";
		$iface=strpos($interface,$str1, $start);
		$iface+=strlen($str1);
		$line_end=strpos($interface,"\n",$iface);
		$ifname = substr($interface,$iface,$line_end-$iface);

		if ($ifname == "ppp0") 
			$this->netiface = self::NET_MODEM;
		else
			$this->netiface = self::NET_ETHERNET;

		$str1="iface $ifname inet ";
		$iface=strpos($interface,$str1, $start);
		$iface+=strlen($str1);
		$conf=substr($interface,$iface,$end-$iface);
		$vals=explode ("\n",$conf);	
		
		if (trim($vals[0])=="dhcp"){
			$this->dhcp=1;
			foreach ($vals as $name){
				if (!(($n=strpos($name,"hostname "))===false)){
					$this->hostname=trim(substr($name, strlen("hostname ")));
				}
			}
		}elseif (trim($vals[0])=="static"){
			$this->dhcp=0;
			foreach ($vals as $name){
				if (!(($n=strpos($name,"address "))===false)){
					$this->address=trim(substr($name, strlen("address")+$n));
				}elseif (!(($n=strpos($name,"netmask "))===false)){
					$this->netmask=trim(substr($name, strlen("netmask")+$n));
				}elseif (!(($n=strpos($name,"gateway "))===false)){
					$this->gateway=trim(substr($name, strlen("gateway")+$n));
				}
			}
		}elseif (trim($vals[0])=="ppp"){
			// nothing else to read, we always use the same ppp config
		} else {
            echo "<p style='color:red'>Warning: unknown inet state: '".$vals[0]."'</p>"; 
        }
	}
}

class dnsconfigBasics{
	var $nameserver1="";
	var $nameserver2="";
	var $nameserver3="";
	var $search="";
	var $domain="";
	var $fname="/etc/network/resolv.conf.static";
	function load(){
		$dns=file_get_contents($this->fname);
		$tmp=$dns;
		$i=1;
		$pos=strpos($tmp,"nameserver");
		while (!($pos===false)){
			$pos+=strlen("nameserver");
			$name="nameserver".$i; 
			$i++;
			$this->$name=trim(substr($tmp,$pos,strpos($tmp,"\n",$pos)-$pos));
			$tmp=substr($tmp,strpos($tmp,"\n",$pos));
			$pos=strpos($tmp,"nameserver");
		}
			
		if (!($pos===false)) 
		$pos=strpos($dns,"search ");
		if (!($pos===false)) {$pos+=strlen("search "); $this->search=trim(substr($dns,$pos,strpos($dns,"\n",$pos)-$pos));}
		$pos=strpos($dns,"domain ");
		if (!($pos===false)) {$pos+=strlen("domain "); $this->domain=trim(substr($dns,$pos,strpos($dns,"\n",$pos)-$pos));}
	}
}

# Returns the location of the video out sysfs, with a trailing slash
function sysfs_vout_device() {
     if (file_exists('/sys/class/x-display/disp0/device')) {
	  return '/sys/class/x-display/disp0/device/';
     } else {
	  return '/sys/class/graphics/fb0/device/';
     }
}


function net_mask_to_prefix($netmask)
{
    $length = 0;
    $vals = explode('.', $netmask);
    if ( count($vals) != 4 )
        return false;
    $expect_zero = false;
    foreach ($vals as $val) {
        if ( ! is_numeric($val) || $val < 0 || $val > 255 )
            return false;
        if ($expect_zero) {
            if ($val != 0)
                return false;
            else
                continue;
        }
        switch ($val) {
        case 255:
            $length += 8; break;
        case 254:
            $length += 7; break;
        case 252:
            $length += 6; break;
        case 248:
            $length += 5; break;
        case 240:
            $length += 4; break;
        case 224:
            $length += 3; break;
        case 192:
            $length += 2; break;
        case 128:
            $length += 1; break;
        case 0:
            $length += 0; break;
        default:
            return false;
        }
        if ($val != 255)
            $expect_zero = true;
    }
    return $length;
}
