<?php
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 13 Jan 1973 15:55:00 GMT"); // Date in the past
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="language" content="en" />
<link rel="shortcut icon" href="css/images/favicon.ico" type="image/x-icon" />
<link rel="stylesheet" type="text/css" href="<?php echo Yii::app()->request->baseUrl; ?>/css/main.css" />
<link rel="stylesheet" type="text/css" href="<?php echo Yii::app()->request->baseUrl; ?>/css/form.css" />
<title><?php 
$devicename= htmlspecialchars(Yii::app()->user->info->serial);
echo $devicename . $this->pageTitle; 
?>
</title>
</head>


<body>
<div id="page">

<div id="header">
<div id="logo">
<h1><?php echo CHtml::encode(Yii::app()->user->branding->maintitle); ?></h1>
</div>
</div> <!-- header -->
<div id="sidebar" > 
<div id="sidebar-left">


<?php 
if ( !Yii::app()->user->status->getFirmwareok () ) 
	$this->widget('application.components.SideMenu',array(
		'title' => 'Corupted Firmware',
		'class' => 'red',
		'items'=>array(
			array('label'=>'Information', 'url'=>array('info/corrupted'), ),
		),
	)); 
    
if ( Yii::app()->user->status->getSafeMode() ) 
	$this->widget('application.components.SideMenu',array(
		'title' => 'Safe Mode',
		'class' => 'red',
		'items'=>array(
			array('label'=>'Information', 'url'=>array('info/safemode'), ),
		),
	)); 
$fusion = new FusionSetup;
if ( $fusion->active ) 
	$this->widget('application.components.SideMenu',array(
		'title' => 'Fusion Enabled',
		'class' => '',
		'items'=>array(
			array('label'=>'Go to Fusion', 'url'=>"http://". Tools::get_my_host()."/fusion/", ),
		),
	)); 
    
$this->widget('application.components.SideMenu',array(
    'title' => 'Information',
	'items'=>array(
		array('label'=>'Status', 'url'=>array('info/status'), ),
        array('label'=>'Snapshot', 'url'=>array('info/snapshot'), ),
        array('label'=>'Display Info', 'url'=>array('info/display'), ),
        array('label'=>'Storage', 'url'=>array('info/storage'), ),
        array('label'=>'Logs', 'url'=>array('info/logs'), ),
	),
)); 

$this->widget('application.components.SideMenu',array(
    'title' => 'Administration',
	'items'=>array(
        array('label'=>'Display Settings', 'url'=>array('/admin/display'), ),
        array('label'=>'Network Settings', 'url'=>array('/admin/network') ),
        array('label'=>'Content Settings', 'url'=>array('/admin/content') ),
		array('label'=>'Security', 'url'=>array('/admin/security') ),
        array('label'=>'Date/Time', 'url'=>array('/admin/time') ),
        array('label'=>'I/O Automation', 'url'=>array('/admin/io') ),
        array('label'=>'Firmware Update', 'url'=>array('/admin/firmware') ),
        array('label'=>'Fusion', 'url'=>array('/admin/fusion'), 'visible'=>Yii::app()->user->branding->fusion ),
        array('label'=>'Maintenance', 'url'=>array('/admin/maintenance') ),
	),
));

if ( Yii::app()->user->advancedMode() ) 
    $this->widget('application.components.SideMenu',array(
        'title' => 'Advanced',
        'items'=>array(
            array('label'=>'Disable', 'url'=>array('/advanced/disable'), ),
            array('label'=>'Player', 'url'=>array('/advanced/player'), ),
            array('label'=>'Logs Settings', 'url'=>array('/advanced/logs') ),
            array('label'=>'Cache Settings', 'url'=>array('/advanced/cache') ),
        ),
    )); 

$this->widget('application.components.SideMenu',array(
    'title' => 'Serial Number',
	'items'=>array(
		array('label'=> Yii::app()->user->info->serialstring),
	),
)); ?>

</div><!-- sidebar-left -->
</div> <!-- sidebar -->

<div id="left-col">


<?php 
if ( Yii::app()->user->tools->doShutdown() )
    Yii::app()->user->tools->shutdown();

if ( Yii::app()->user->tools->reboot ) {
    echo "<div id='nav'>\n";
    echo "</div>\n";
    echo "<div id='contentbg' class='content'>\n";
        
    $this->renderPartial('/layouts/shutdown', array(    'reason'=>Yii::app()->user->tools->shutdownReason, 
                                                        'message'=>Yii::app()->user->tools->message, 
                                                        'redirect' => Yii::app()->user->tools->redirect
                                                    ) );
    
} else { 
    if ( Yii::app()->user->status->installationmode || Yii::app()->user->tools->hasErrors() ) {
        echo "<div id='nav'>\n";
        echo "</div>\n";
        echo "<div id='contentbg' class='content' >\n";
        if ( Yii::app()->user->status->installationmode )
            $this->renderPartial('/layouts/instalation' );
        else 
            echo CHtml::errorSummary( Yii::app()->user->tools)  ."\n";
        if ( Yii::app()->user->tools->hasHeader ) {
            echo "</div>\n";
            echo "<div id='content' class='content'>\n";
        } 
    } else {
        if ( Yii::app()->user->tools->hasHeader ) {
            echo "<div id='content' class='content'>\n";
        } else {
            echo "<div id='nav'>\n";
            echo "</div>\n";
            echo "<div id='contentbg' class='content'>\n";
        }
    }
    
    echo $content; 
}


            
?>
</div><!-- content -->

<div id="footer">
<div id="footer-text">
<?php
echo Yii::app()->user->branding->copyrights;
?>
<br/>
<?php echo CHtml::link("Software copyrights and licences", array("/info/about") ); ?>
</div><!-- footer-text -->
</div><!-- footer -->

</div><!-- left-col -->

</div><!-- page -->
</body>

</html>